/* gmcalabel.h */

#ifndef __GMCAL_ABEL_H__
#define __GMCAL_ABEL_H__

#include <gmcal/gmcalenum.h>
#include <glib.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
  GMCAL_ABEL_WRONG_IMPLEMENTATION=GMCAL_ABEL*1000,
  GMCAL_ABEL_MIDDLE_UNDETERMINED,
  GMCAL_ABEL_MATRIX_TOO_SMALL
};

gint	gmcal_abel_create_symmetrical_copy	(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint dimX,
						gint dimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint not_used_yet);

gint	gmcal_abel_create_transformed_copy	(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint olddimX,
						gint olddimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint not_used_yet);

gint	gmcal_abel_create_inverse_by_matrix	(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint olddimX,
						gint olddimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint not_used_yet);

gint	gmcal_abel_create_inverse_by_back_distribution(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint olddimX,
						gint olddimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint iterations);

gint	gmcal_abel_create_inverse_by_back_distribution_average(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint olddimX,
						gint olddimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint iterations);

gint	gmcal_abel_create_inverse_by_pre_calculated_back_distribution_average(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint olddimX,
						gint olddimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint iterations);

gint	gmcal_abel_create_inverse_by_spline_expansion_real(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint olddimX,
						gint olddimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint knotN);

gint	gmcal_abel_create_inverse_by_fourier_expansion_real(gfloat *oldX,
						gfloat *oldY,
						gfloat **oldZ,
						gint olddimX,
						gint olddimY,
						gfloat **newX,
						gfloat **newY,
						gfloat ***newZ,
						gint *newdimX,
						gint *newdimY,
						gint knotN);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GMCAL_ABEL_H__ */

