/* gmcalbasic.h */

#ifndef __GMCAL_BASIC_H__
#define __GMCAL_BASIC_H__

#include <gmcal/gmcalenum.h>
#include <glib.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
  GMCAL_BASIC_NOT_IMPLEMENTED=GMCAL_BASIC*1000,
};

gint	gmcal_basic_matrix_new			(gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint dimX,
						gint dimY);

gint	gmcal_basic_matrix_free			(gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint dimX,
						gint dimY);

gint	gmcal_basic_vector_fill_with_index	(gfloat *X,
						gint dimX);

gint	gmcal_basic_vector_check_integrity	(gfloat *X,
						gint dimX);

gint	gmcal_basic_matrix_check_integrity	(gfloat *X,
						gfloat *Y,
						gfloat **Z,
						gint dimX,
						gint dimY);

gint	gmcal_basic_matrix_core_check_integrity	(gfloat **Z,
						gint dimX,
						gint dimY);

gint 	gmcal_basic_matrix_double_invert	(gdouble **matrix, 
						gint n);

gint 	gmcal_basic_matrix_double_solve_equ_sys	(gdouble **matrix, 
						gint n,
						gdouble *inhomogen,
						double *solution);

						
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GMCAL_BASIC_H__ */

