/* gmcalread.h */

#ifndef __GMCAL_READ_H__
#define __GMCAL_READ_H__

#include <gmcal/gmcalenum.h>
#include <glib.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
  GMCAL_READ_WRONG_IMPLEMENTATION=GMCAL_READ*1000,
  GMCAL_READ_NO_PATH,
  GMCAL_READ_COULD_NOT_OPEN,
  GMCAL_READ_FILE_TOO_SMALL,
  GMCAL_READ_NOT_IMPLEMENTED,
  GMCAL_READ_CORRUPT_HEADER
};

gint	gmcal_read_line				(gchar **line,
						gint *actual_len,
						FILE *fp);

gint	gmcal_read_float_bin_vector_simple	(gchar *path, 
						gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint *dimX,
						gint *dimY,
						gchar **info);

gint	gmcal_read_float_bin_matrix_gmcal	(gchar *path, 
						gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint *dimX,
						gint *dimY,
						gchar **info);

gint	gmcal_read_float_bin_matrix_csma	(gchar *path, 
						gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint *dimX,
						gint *dimY,
						gchar **info);

gint	gmcal_read_float_bin_matrix_oma4	(gchar *path, 
						gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint *dimX,
						gint *dimY,
						gchar **info);

gint	gmcal_read_float_bmp_matrix_pco		(gchar *path, 
						gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint *dimX,
						gint *dimY,
						gchar **info);

gint	gmcal_read_float_ascii_matrix_gmcal	(gchar *path, 
						gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint *dimX,
						gint *dimY,
						gchar **info);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GMCAL_READ_H__ */

