/* gmcalsimple.h */

#ifndef __GMCAL_SIMPLE_H__
#define __GMCAL_SIMPLE_H__

#include <gmcal/gmcalenum.h>
#include <glib.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
  GMCAL_SIMPLE_NOT_IMPLEMENTED=GMCAL_SIMPLE*1000
};

gint gmcal_simple_matrix_multiply_number		(gfloat **Z,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_matrix_divide_number			(gfloat **Z,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_matrix_add_number			(gfloat **Z,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_matrix_subtract_number		(gfloat **Z,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_matrix_multiply_matrix_times_number	(gfloat **Z,
							gfloat **Z1,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_matrix_divide_matrix_times_number	(gfloat **Z,
							gfloat **Z1,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_matrix_add_matrix_times_number	(gfloat **Z,
							gfloat **Z1,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_matrix_subtract_matrix_times_number	(gfloat **Z,
							gfloat **Z1,
							gint dimX,
							gint dimY,
							gfloat number);

gint gmcal_simple_create_matrix_transposed		(gfloat *oldX,
							gfloat *oldY,
							gfloat **oldZ,
							gint olddimX,
							gint olddimY,
							gfloat **newX,
							gfloat **newY,
							gfloat ***newZ,
							gint *newdimX,
							gint *newdimY);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GMCAL_SIMPLE_H__ */

