/* gmcalspline.h */

#ifndef __GMCAL_SPLINE_H__
#define __GMCAL_SPLINE_H__

#include <gmcal/gmcalenum.h>
#include <glib.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
  GMCAL_SPLINE_NOT_ENOUGH_VALUES=GMCAL_SPLINE*1000,
  GMCAL_SPLINE_X_VALUES_NOT_DISTINCT,
  GMCAL_SPLINE_X_VALUES_UNSORTED,
  GMCAL_SPLINE_POLY_IS_NULL,
  GMCAL_SPLINE_POLY_0_NOT_NULL,
  GMCAL_SPLINE_COEFF_IS_NULL,
  GMCAL_SPLINE_COEFF_0_NOT_NULL
};

gint	gmcal_spline_get_coeff			(gfloat *x,
						gfloat *y,
						gint n,
						gdouble **coeff);

gint	gmcal_spline_get_poly_coeff		(gfloat *x, 
						gfloat *y,
						gint nY,
						gdouble *coeff,
						gdouble ***poly);

gint	gmcal_spline_get_interval		(gfloat *x, 
						gint n,
						float x_value);

gdouble	gmcal_spline_get_value			(gfloat *x,
						gfloat *y,
						gint n,
						gdouble *coeff,
						gfloat x_value,
						gint interval);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GMCAL_SPLINE_H__ */

