/* gmcalwrite.h */

#ifndef __GMCAL_WRITE_H__
#define __GMCAL_WRITE_H__

#include <gmcal/gmcalenum.h>
#include <glib.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
  GMCAL_WRITE_WRONG_IMPLEMENTATION=GMCAL_WRITE*1000,
  GMCAL_WRITE_NO_PATH,
  GMCAL_WRITE_COULD_NOT_OPEN
};

gint	gmcal_write_float_bin_vector_simple	(gchar *path, 
						gfloat *Z,
						gint dimX);

gint	gmcal_write_float_bin_matrix_gmcal	(gchar *path, 
						gfloat *X,
						gfloat *Y,
						gfloat **Z,
						gint dimX,
						gint dimY,
						gchar *info);

gint	gmcal_write_float_ascii_matrix_gmcal	(gchar *path, 
						gfloat *X,
						gfloat *Y,
						gfloat **Z,
						gint dimX,
						gint dimY,
						gchar *info);

gint	gmcal_write_float_gif_matrices_with_info(gchar *path, 
						gfloat **X,
						gfloat **Y,
						gfloat ***Z,
						gint *dimX,
						gint *dimY,
						gchar **info,
						gint num,
						gchar *model,
						gint maxColors,
						gint mode,
						gint imagesPerRow);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GMCAL_WRITE_H__ */

