/* gtkextfilesel.h */

#ifndef __GTK_EXTFILESEL_H__
#define __GTK_EXTFILESEL_H__


#include <gtk/gtkfilesel.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_TYPE_EXTENDED_FILE_SELECTION            (gtk_extended_file_selection_get_type ())
#define GTK_EXTENDED_FILE_SELECTION(obj)            GTK_CHECK_CAST (obj, gtk_extended_file_selection_get_type (), GtkExtendedFileSelection)
#define GTK_EXTENDED_FILE_SELECTION_CLASS(klass)    GTK_CHECK_CLASS_CAST (klass, gtk_extended_file_selection_get_type (), GtkExtendedFileSelectionClass)
#define GTK_IS_EXTENDED_FILE_SELECTION(obj)         GTK_CHECK_TYPE (obj, gtk_extended_file_selection_get_type ())
#define GTK_IS_EXTENDED_FILE_SELECTION_CLASS(klass) GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_EXTENDED_FILE_SELECTION))


typedef struct _GtkExtendedFileSelection       GtkExtendedFileSelection;
typedef struct _GtkExtendedFileSelectionClass  GtkExtendedFileSelectionClass;

struct _GtkExtendedFileSelection
{
  GtkFileSelection file_selection;
  
  gint file_type;
  GtkWidget *combo;
};

struct _GtkExtendedFileSelectionClass
{
  GtkFileSelectionClass parent_class;
  void (* extended_file_list_changed) (GtkExtendedFileSelection *efs);
};

guint		gtk_extended_file_selection_get_type		(void);
GtkWidget*	gtk_extended_file_selection_new			(gchar *title);
void 		gtk_extended_file_selection_goto		(GtkExtendedFileSelection *efs);
GtkWidget *	gtk_extended_file_selection_type_popup		(GtkExtendedFileSelection *efs,
				                                GList *types,
				                                guint index);
                                
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GTK_EXTFILESEL_H__ */

