#ifndef __GMCAL_SCRIPT_H__
#define __GMCAL_SCRIPT_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

enum {
  GMCAL_SCRIPT_INT=1,
  GMCAL_SCRIPT_FLOAT,
  GMCAL_SCRIPT_EXIT,
  GMCAL_SCRIPT_VOID
};

#define error 	printf("Error: "); printf
#define warning	printf("<FONT COLOR=\"RED\" BGCOLOR=\"BLACK\" SIZE=\"+1\">Warning:</FONT> "); printf

#define max(x,y) (x>y)?x:y
#define min(x,y) (x<y)?x:y

struct gmcal_data {
  char *info;
  char *path;
  int index;
  int dimX;
  int dimY;
  float *X;
  float *Y;
  float minX;
  float minY;
  float minZ;
  float maxX;
  float maxY;
  float maxZ;
  float **Z;
  struct gmcal_data *next;
  struct gmcal_data *previous;
};

typedef struct gmcal_data gmcal_data;

struct gmcal_func_init
{
  int type;
  char *fname;
  void (*fnct)();  
  int no_args;
  char *parameters;
  char *par_list;
};

typedef struct gmcal_func_init gmcal_func_init;

void gmcal_script_init_matrix();
void gmcal_init_script();
int yyparse();

#endif /* __GMCAL_SCRIPT_H__ */
