#include <script.h>

/* Data type for links in the chain of symbols.      */
struct symrec
{
  char *name;  /* name of symbol                     */
  int type;    /* type of symbol: either X_VAR or X_FNCT */
  union {
    double	d_var;
    int	l_var;
    char	*s_var;
    double	(* d_fnc)();
    int		(* l_fnc)();
    char	*(* s_fnc)();
    void	(* v_fnc)();
  } value;
  int no_args;
  int *parameters;
  char *par_list;
  struct symrec *next;    /* link field              */
};
typedef struct symrec symrec;

/* The symbol table: a chain of truct symrec'.     */
symrec *sym_table;

symrec *putsym ();
symrec *getsym ();
symrec *addarg();
symrec *newarg();

