#ifndef __GMCAL_SCRIPT_LANGUAGE_INIT_H__
#define __GMCAL_SCRIPT_LANGUAGE_INIT_H__

#include <script.h>

double gmcal_sin();			/**/
double gmcal_cos();			/**/

int gmcal_commandList();		/**/
int gmcal_newMatrix();			/**/
int gmcal_newMatrixWithValue();		/**/
int gmcal_getDimX();			/**/
int gmcal_getDimY();			/**/
int gmcal_DestroyMatrix();		/**/
int gmcal_DestroyAllMatrices();		/**/
int gmcal_copyMatrix();			/**/
int gmcal_createCopyWithNormedRows();	/**/
int gmcal_createCopyWithNormedCols();  	/**/
int gmcal_createCopyWithNormedMatrix();	/**/
int gmcal_flipMatrixRows();		/**/
int gmcal_flipMatrixCols();		/**/
int gmcal_createMatrixCut();		/**/
int gmcal_createResizedMatrix();	/**/
int gmcal_createTransposedMatrix();	/**/
int gmcal_createSymmetricalCopy();	/**/
int gmcal_createMatrixFromRow();	/**/
int gmcal_createAbelTransformedMatrix();/**/
int gmcal_createAbelBackDistribution();	/**/
int gmcal_createAbelBackDistributionAverage();	/**/
int gmcal_createAbelSplineExpansion();	/**/
int gmcal_createAbelFourierExpansion();	/**/
int gmcal_createAbelMatrixInverse();	/**/
int gmcal_setDispersionXfromRow();	/**/
int gmcal_loadASCIIMatrix();		/**/
int gmcal_loadBMPMatrix();		/**/
int gmcal_loadSpecMatrix();		/**/
int gmcal_loadBinMatrix();		/**/
int gmcal_loadOma4Matrix();		/**/
int gmcal_loadBinVector();		/**/
int gmcal_saveRowAsStar();		/**/
int gmcal_saveBinMatrix();		/**/
int gmcal_saveASCIIMatrix();		/**/
int gmcal_saveGif();			/**/
int gmcal_saveAllGif();			/**/
int gmcal_addMatrixToMatrix();		/**/
int gmcal_addNumberToMatrix();		/**/
int gmcal_multiplyMatrixByMatrix();	/**/
int gmcal_multiplyMatrixByNumber();	/**/
int gmcal_divideMatrixByMatrix();	/**/
int gmcal_divideMatrixByNumber();	/**/
int gmcal_rowPolynom();			/**/
int gmcal_colPolynom();			/**/
int gmcal_setDispersionX();		/**/
int gmcal_setMatrixEntry();		/**/
int gmcal_createSplineFromXAndRow();	/**/
int gmcal_createPlanckFromX();		/**/
int gmcal_setMatrixInfo();		/**/
int gmcal_abelInversionFourier();	/**/
float gmcal_getMinX();			/**/
float gmcal_getMaxX();			/**/
float gmcal_getMinY();			/**/
float gmcal_getMaxY();			/**/



struct gmcal_func_init gmcal_funcs[]
   = {
    {GMCAL_SCRIPT_FLOAT, "sin", (void *) gmcal_sin, 1,"float","float arg"},
    {GMCAL_SCRIPT_FLOAT, "cos", (void *) gmcal_cos, 1,"float","float arg"},
    {GMCAL_SCRIPT_FLOAT, "getMinX", (void *) gmcal_getMinX, 1,"int","int matrix"},
    {GMCAL_SCRIPT_FLOAT, "getMaxX", (void *) gmcal_getMaxX, 1,"int","int matrix"},
    {GMCAL_SCRIPT_FLOAT, "getMinY", (void *) gmcal_getMinY, 1,"int","int matrix"},
    {GMCAL_SCRIPT_FLOAT, "getMaxY", (void *) gmcal_getMaxY, 1,"int","int matrix"},
    {GMCAL_SCRIPT_INT, "getDimX", (void *) gmcal_getDimX, 1,"int","int matrix"},
    {GMCAL_SCRIPT_INT, "getDimY", (void *) gmcal_getDimY, 1,"int","int matrix"},
    {GMCAL_SCRIPT_INT, "commandList", (void *) gmcal_commandList, 0, 0, ""},
    {GMCAL_SCRIPT_INT, "newMatrix", (void *) gmcal_newMatrix, 6, "int,int,float,float,float,float", "int dimX, int dimY, float minX, float maxX, float minY, float maxY"},
    {GMCAL_SCRIPT_INT, "newMatrixWithValue", (void *) gmcal_newMatrixWithValue, 7, "int,int,float,float,float,float,float", "int dimX, int dimY, float minX, float maxX, float minY, float maxY, float value"},
    {GMCAL_SCRIPT_INT, "destroyMatrix", (void *) gmcal_DestroyMatrix, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "destroyAllMatrices", (void *) gmcal_DestroyAllMatrices, 0, "", ""},
    {GMCAL_SCRIPT_INT, "copyMatrix", (void *) gmcal_copyMatrix, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "setMatrixEntry", (void *) gmcal_setMatrixEntry, 4, "int,int,int,float", "int index, int row, int col, float value"},
    {GMCAL_SCRIPT_INT, "setDispersionX", (void *) gmcal_setDispersionX, 3, "int,float,float", "int index, float min, float max"},
    {GMCAL_SCRIPT_INT, "setMatrixInfo", (void *) gmcal_setMatrixInfo, 2, "int,string", "int index, string info"},
    {GMCAL_SCRIPT_INT, "loadASCIIMatrix", (void *) gmcal_loadASCIIMatrix, 1, "string","string path"},
    {GMCAL_SCRIPT_INT, "loadBMPMatrix", (void *) gmcal_loadBMPMatrix, 1, "string","string path"},
    {GMCAL_SCRIPT_INT, "loadSpecMatrix", (void *) gmcal_loadSpecMatrix, 1, "string","string path"},
    {GMCAL_SCRIPT_INT, "loadOma4Matrix", (void *) gmcal_loadOma4Matrix, 1, "string","string path"},
    {GMCAL_SCRIPT_INT, "loadBinMatrix", (void *) gmcal_loadBinMatrix, 1, "string","string path"},
    {GMCAL_SCRIPT_INT, "loadBinVector", (void *) gmcal_loadBinVector, 1, "string","string path"},
    {GMCAL_SCRIPT_INT, "saveBinMatrix", (void *) gmcal_saveBinMatrix, 2, "int,string","int index, string path"},
    {GMCAL_SCRIPT_INT, "saveRowAsStar", (void *) gmcal_saveRowAsStar, 3, "int,int,string","int index, int row, string path"},
    {GMCAL_SCRIPT_INT, "saveASCIIMatrix", (void *) gmcal_saveASCIIMatrix, 2, "int,string","int index, string path"},
    {GMCAL_SCRIPT_INT, "saveGif", (void *) gmcal_saveGif, 5, "int,string,string,int,int","int index, string gifPath, string model, int maxColors, int mode"},
    {GMCAL_SCRIPT_INT, "saveAllGif", (void *) gmcal_saveAllGif, 5, "string,string,int,int,int","string gifPath, string model, int maxColors, int mode, int imagesPerRow"},
    {GMCAL_SCRIPT_INT, "createSymmetricalCopy", (void *) gmcal_createSymmetricalCopy, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "createAbelTransformedMatrix", (void *) gmcal_createAbelTransformedMatrix, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "createAbelBackDistribution", (void *) gmcal_createAbelBackDistribution, 2, "int,int", "int index, int iterations"},
    {GMCAL_SCRIPT_INT, "createAbelBackDistributionAverage", (void *) gmcal_createAbelBackDistributionAverage, 2, "int,int", "int index, int iterations"},
    {GMCAL_SCRIPT_INT, "createAbelSplineExpansion", (void *) gmcal_createAbelSplineExpansion, 2, "int,int", "int index, int iterations"},
    {GMCAL_SCRIPT_INT, "createAbelFourierExpansion", (void *) gmcal_createAbelFourierExpansion, 2, "int,int", "int index, int iterations"},
    {GMCAL_SCRIPT_INT, "createTransposedMatrix", (void *) gmcal_createTransposedMatrix, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "createAbelMatrixInverse", (void *) gmcal_createAbelMatrixInverse, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "addMatrixToMatrix", (void *) gmcal_addMatrixToMatrix, 3, "int,int,float", "int index, int index2, float factor"},
    {GMCAL_SCRIPT_INT, "addNumberToMatrix", (void *) gmcal_addNumberToMatrix, 2, "int,float", "int index, float add"},
    {GMCAL_SCRIPT_INT, "multiplyMatrixByMatrix", (void *) gmcal_multiplyMatrixByMatrix, 3, "int,int,float", "int index, int index2, float factor"},
    {GMCAL_SCRIPT_INT, "multiplyMatrixByNumber", (void *) gmcal_multiplyMatrixByNumber, 2, "int,float", "int index, float add"},
    {GMCAL_SCRIPT_INT, "divideMatrixByMatrix", (void *) gmcal_divideMatrixByMatrix, 3, "int,int,float", "int index, int index2, float factor"},
    {GMCAL_SCRIPT_INT, "divideMatrixByNumber", (void *) gmcal_divideMatrixByNumber, 2, "int,float", "int index, float add"},
    {GMCAL_SCRIPT_INT, "createCopyWithNormedRows", (void *) gmcal_createCopyWithNormedRows, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "createCopyWithNormedCols", (void *) gmcal_createCopyWithNormedCols, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "createCopyWithNormedMatrix", (void *) gmcal_createCopyWithNormedMatrix, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "rowPolynom", (void *) gmcal_rowPolynom, 8, "int,int,float,float,float,float,float,float", "int index, int row, float a0, float a1, float a2, float a3, float a4, float a5"},
    {GMCAL_SCRIPT_INT, "colPolynom", (void *) gmcal_colPolynom, 8, "int,int,float,float,float,float,float,float", "int index, int col, float a0, float a1, float a2, float a3, float a4, float a5"},
    {GMCAL_SCRIPT_INT, "flipMatrixRows", (void *) gmcal_flipMatrixRows, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "flipMatrixCols", (void *) gmcal_flipMatrixCols, 1, "int", "int index"},
    {GMCAL_SCRIPT_INT, "createMatrixCut", (void *) gmcal_createMatrixCut, 5, "int,int,int,int,int", "int index, int left, int top, int width, int height"},
    {GMCAL_SCRIPT_INT, "createResizedMatrix", (void *) gmcal_createResizedMatrix, 3, "int,int,int", "int index, int shrinkX, int shrinkY"},
    {GMCAL_SCRIPT_INT, "createMatrixFromRow", (void *) gmcal_createMatrixFromRow, 3, "int,int,int", "int index, int row, int rowcount"},
    {GMCAL_SCRIPT_INT, "createPlanckFromX", (void *) gmcal_createPlanckFromX, 2, "int,float", "int index, float temperature"},
    {GMCAL_SCRIPT_INT, "createSplineFromXAndRow", (void *) gmcal_createSplineFromXAndRow, 5, "int,int,float,float,int", "int index, int row, float minX, float maxX, int steps"},
    {GMCAL_SCRIPT_INT, "setDispersionXfromRow", (void *) gmcal_setDispersionXfromRow, 3, "int,int,int", "int indexTarget, int indexSource, int row"},
    {GMCAL_SCRIPT_EXIT, "exit", (void *) exit, 0, 0, 0},
    {GMCAL_SCRIPT_EXIT, "quit", (void *) exit, 0, 0, 0},
    {GMCAL_SCRIPT_EXIT, "bye", (void *) exit, 0, 0, 0}, 
    {0, 0, 0, 0, 0},
};


#endif /* __GMCAL_SCRIPT_LANGUAGE_INIT_H__ */
