#include <script_language.h>
#include <script_matrix.h>

int gmcal_createMatrixCut(symrec *params)
{
  symrec pars;
  int width, height;
  int top, left;
  
  int index;
  
  pars=*params;
  
  height=pars.value.l_var; pars=*(pars.next);
  width=pars.value.l_var; pars=*(pars.next);
  top=pars.value.l_var; pars=*(pars.next);
  left=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Creating Cut from Matrix %d, left: %d, top: %d, width: %d, height: %d\n", index, left, top, width, height); 
  
  return gmcal_script_create_matrix_cut(index, left, top, width, height);
}

int gmcal_getDimX(symrec *params)
{
  symrec pars;
  int index;
  int dimX, dimY;
  float minX, maxX, minY, maxY;


  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Getting dimX of matrix %d\n", index); 
  
  gmcal_script_get_matrix_attributes(index, &dimX, &dimY, &minX, &maxX, &minY, &maxY);
  
  return dimX;
}

int gmcal_getDimY(symrec *params)
{
  symrec pars;
  int index;
  int dimX, dimY;
  float minX, maxX, minY, maxY;

  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Getting dimY of matrix %d\n", index); 
  
  gmcal_script_get_matrix_attributes(index, &dimX, &dimY, &minX, &maxX, &minY, &maxY);
  
  return dimY;
}

float gmcal_getMinX(symrec *params)
{
  symrec pars;
  int index;
  int dimX, dimY;
  float minX, maxX, minY, maxY;

  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Getting minX of matrix %d\n", index); 
  
  gmcal_script_get_matrix_attributes(index, &dimX, &dimY, &minX, &maxX, &minY, &maxY);
  
  return minX;
}

float gmcal_getMaxX(symrec *params)
{
  symrec pars;
  int index;
  int dimX, dimY;
  float minX, maxX, minY, maxY;

  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Getting maxX of matrix %d\n", index); 
  
  gmcal_script_get_matrix_attributes(index, &dimX, &dimY, &minX, &maxX, &minY, &maxY);
  
  return maxX;
}

float gmcal_getMinY(symrec *params)
{
  symrec pars;
  int index;
  int dimX, dimY;
  float minX, maxX, minY, maxY;

  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Getting minY of matrix %d\n", index); 
  
  gmcal_script_get_matrix_attributes(index, &dimX, &dimY, &minX, &maxX, &minY, &maxY);
  
  return minY;
}

float gmcal_getMaxY(symrec *params)
{
  symrec pars;
  int index;
  int dimX, dimY;
  float minX, maxX, minY, maxY;

  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Getting maxY of matrix %d\n", index); 
  
  gmcal_script_get_matrix_attributes(index, &dimX, &dimY, &minX, &maxX, &minY, &maxY);
  
  return maxY;
}

int gmcal_createCopyWithNormedRows(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Creating copy of matrix %d with normed Rows\n", index); 
  
  return gmcal_script_create_copy_with_normed_rows(index);
}

int gmcal_createCopyWithNormedCols(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Creating copy of matrix %d with normed Cols\n", index); 
  
  return gmcal_script_create_copy_with_normed_cols(index);
}

int gmcal_createCopyWithNormedMatrix(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Creating copy of matrix %d with normed matrix\n", index); 
  
  return gmcal_script_create_copy_with_normed_matrix(index);
}

int gmcal_createTransposedMatrix(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Transposing matrix %d\n", index); 
  
  return gmcal_script_create_transposed_matrix(index);
}

int gmcal_saveGif(symrec *params)
{
  symrec pars;
  int index;
  char *path;
  char *model;
  int maxColors;
  int mode;
  
  pars=*params;
  
  mode=pars.value.l_var; pars=*(pars.next);
  maxColors=pars.value.l_var; pars=*(pars.next);
  model=pars.value.s_var; pars=*(pars.next);
  path=pars.value.s_var; pars=*(pars.next);
  index=pars.value.l_var;

  printf("Saving Matrix %d as Gif at %s with %d colors\n", index, path, maxColors); 
  
  return gmcal_script_write_gif(index, path, model, maxColors, mode);
}

int gmcal_saveAllGif(symrec *params)
{
  symrec pars;
  int imagesPerRow;
  char *path;
  char *model;
  int maxColors;
  int mode;
  
  pars=*params;
  
  imagesPerRow=pars.value.l_var; pars=*(pars.next);
  mode=pars.value.l_var; pars=*(pars.next);
  maxColors=pars.value.l_var; pars=*(pars.next);
  model=pars.value.s_var; pars=*(pars.next);
  path=pars.value.s_var;

  printf("Saving all matrices in memory at %s with %d colors\n", path, maxColors); 
  
  return gmcal_script_write_all_gif(path, model, maxColors, mode, imagesPerRow);
}

int gmcal_createAbelTransformedMatrix(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Creating Abel-transformed copy of matrix %d\n", index); 
  
  return gmcal_script_create_abel_copy(index, GMCAL_SCRIPT_ABEL_TRANSFORM, -1);
}

int gmcal_createAbelMatrixInverse(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Creating Abel-Inverse of matrix %d by Matrix-Method\n", index); 
  
  return gmcal_script_create_abel_copy(index, GMCAL_SCRIPT_ABEL_MATRIX_INVERSE, -1);
}

int gmcal_createAbelBackDistribution(symrec *params)
{
  symrec pars;
  int index;
  int iterations;
  
  pars=*params;
  
  iterations=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Creating Abel-Inversion matrix %d by back-distribution method, %d iterations\n", index, iterations); 
  
  return gmcal_script_create_abel_copy(index, GMCAL_SCRIPT_ABEL_BACK_DISTRIBUTION_INVERSE, iterations);
}

int gmcal_createAbelBackDistributionAverage(symrec *params)
{
  symrec pars;
  int index;
  int iterations;
  
  pars=*params;
  
  iterations=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Creating Abel-Inversion matrix %d by back-distribution method, %d iterations\n", index, iterations); 
  
  return gmcal_script_create_abel_copy(index, GMCAL_SCRIPT_ABEL_AVERAGE_BACK_DISTRIBUTION_INVERSE, iterations);
}

int gmcal_createAbelSplineExpansion(symrec *params)
{
  symrec pars;
  int index;
  int knotN;
  
  pars=*params;
  
  knotN=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Creating Abel-Inversion of matrix %d by spline expansion in the \"real\" space, %d spline knots\n", index, knotN); 
  
  return gmcal_script_create_abel_copy(index, GMCAL_SCRIPT_ABEL_SPLINE_REAL_INVERSE, knotN);
}

int gmcal_createAbelFourierExpansion(symrec *params)
{
  symrec pars;
  int index;
  int knotN;
  
  pars=*params;
  
  knotN=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Creating Abel-Inversion of matrix %d by spline expansion in the \"real\" space, %d spline knots\n", index, knotN); 
  
  return gmcal_script_create_abel_copy(index, GMCAL_SCRIPT_ABEL_FOURIER_REAL_INVERSE, knotN);
}

int gmcal_createSymmetricalCopy(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Creating symmetrical copy of matrix %d\n", index); 
  
  return gmcal_script_create_abel_copy(index, GMCAL_SCRIPT_ABEL_SYMMETRICAL, -1);
}

int gmcal_loadASCIIMatrix(symrec *params)
{
  symrec pars;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var;

  printf("Loading ASCII Matrix from %s\n", path); 
  
  return gmcal_script_load_matrix(path, GMCAL_SCRIPT_ASCII);
}

int gmcal_loadBMPMatrix(symrec *params)
{
  symrec pars;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var;

  printf("Loading ASCII Matrix from %s\n", path); 
  
  return gmcal_script_load_matrix(path, GMCAL_SCRIPT_BMP);
}

int gmcal_loadBinMatrix(symrec *params)
{
  symrec pars;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var;

  printf("Loading binary Matrix from %s\n", path); 
  
  return gmcal_script_load_matrix(path, GMCAL_SCRIPT_BIN);
}

int gmcal_loadBinVector(symrec *params)
{
  symrec pars;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var;

  printf("Loading binary Vector from %s\n", path); 
  
  return gmcal_script_load_matrix(path, GMCAL_SCRIPT_BIN_VECTOR);
}

int gmcal_loadSpecMatrix(symrec *params)
{
  symrec pars;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var;

  printf("Loading spec/CSMA Matrix from %s\n", path); 
  
  return gmcal_script_load_matrix(path, GMCAL_SCRIPT_SPEC);
}

int gmcal_loadOma4Matrix(symrec *params)
{
  symrec pars;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var;

  printf("Loading Oma4 Matrix from %s\n", path); 
  
  return gmcal_script_load_matrix(path, GMCAL_SCRIPT_OMA4);
}


int gmcal_newMatrix(symrec *params)
{
  symrec pars;
  int dimX, dimY;
  double minX, maxX, minY, maxY;
  
  pars=*params;
  
  maxY=pars.value.d_var; pars=*(pars.next);
  minY=pars.value.d_var; pars=*(pars.next);
  maxX=pars.value.d_var; pars=*(pars.next);
  minX=pars.value.d_var; pars=*(pars.next);
  dimY=pars.value.l_var; pars=*(pars.next);
  dimX=pars.value.l_var;
  
  printf("Creating %d x %d Matrix, X from %g to %g, Y from %g to %g\n", dimX,dimY, minX, maxX, minY, maxY); 
  
  return gmcal_script_new_matrix(dimX, dimY, minX, maxX, minY, maxY, 0);

}

int gmcal_newMatrixWithValue(symrec *params)
{
  symrec pars;
  int dimX, dimY;
  float minX, maxX, minY, maxY;
  float value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  maxY=pars.value.d_var; pars=*(pars.next);
  minY=pars.value.d_var; pars=*(pars.next);
  maxX=pars.value.d_var; pars=*(pars.next);
  minX=pars.value.d_var; pars=*(pars.next);
  dimY=pars.value.l_var; pars=*(pars.next);
  dimX=pars.value.l_var;
  
  printf("Creating %d x %d Matrix with value %g, X from %g to %g, Y from %g to %g\n", dimX,dimY, value, minX, maxX, minY, maxY); 
  
  return gmcal_script_new_matrix(dimX, dimY, minX, maxX, minY, maxY, value);

}

int gmcal_DestroyMatrix(symrec *params)
{
  symrec pars;
  int index;
  
  pars=*params;
  
  index=pars.value.l_var; 
  
  printf("Destroying Matrix %d\n", index); 
  
  return gmcal_script_destroy_matrix(index);

}

int gmcal_DestroyAllMatrices(symrec *params)
{
  printf("Destroying All Matrices\n"); 
  
  return gmcal_script_destroy_all_matrices();

}

int gmcal_setMatrixEntry(symrec *params)
{
  symrec pars;
  int index;
  int row;
  int col;
  double value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  col=pars.value.l_var; pars=*(pars.next);
  row=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Setting Matrix %d entry %d, %d to %g\n", index, row, col, value); 
  
  return gmcal_script_set_matrix_entry(index, row, col, value);
}

int gmcal_setDispersionX(symrec *params)
{
  symrec pars;
  int index;
  float min, max;
  
  pars=*params;
  
  max=pars.value.d_var; pars=*(pars.next);
  min=pars.value.d_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Setting dispersion of matrix %d entry from %g to %g\n", index, min, max); 
  
  return gmcal_script_set_dispersion_x(index, min, max);
}

int gmcal_setMatrixInfo(symrec *params)
{
  symrec pars;
  int index;
  char *info;
  
  pars=*params;
  
  info=pars.value.s_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Setting matrix %d info to %s\n", index, info); 
  
  return gmcal_script_set_matrix_info(index, info);
}

int gmcal_copyMatrix(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Copying Matrix %d\n", index); 
  
  return gmcal_script_copy_matrix(index);
}

int gmcal_saveASCIIMatrix(symrec *params)
{
  symrec pars;
  int index;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var; pars=*(pars.next);
  index=pars.value.l_var;

  printf("Saving ASCII Matrix %d at %s\n", index, path); 
  
  return gmcal_script_write_matrix(index, path, GMCAL_SCRIPT_ASCII);
}

int gmcal_saveBinMatrix(symrec *params)
{
  symrec pars;
  int index;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var; pars=*(pars.next);
  index=pars.value.l_var;

  printf("Saving Binary Matrix %d at %s\n", index, path); 
  
  return gmcal_script_write_matrix(index, path, GMCAL_SCRIPT_BIN);
}

int gmcal_saveRowAsStar(symrec *params)
{
  symrec pars;
  int index;
  int row;
  char *path;
  
  pars=*params;
  
  path=pars.value.s_var; pars=*(pars.next);
  row=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;

  printf("Saving row %d of Matrix %d at %s (star)\n", row, index, path); 
  
  return gmcal_script_write_row_as_star(index, row, path);
}

int gmcal_addMatrixToMatrix(symrec *params)
{
  symrec pars;
  int index;
  int index2;
  double value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  index2=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Adding %g times Matrix %d to matrix %d\n", value, index2, index); 
  
  return gmcal_script_add_matrix_to_matrix(index, index2, value);
}

int gmcal_addNumberToMatrix(symrec *params)
{
  symrec pars;
  int index;
  double value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Adding %g to matrix %d\n", value, index); 
  
  return gmcal_script_add_number_to_matrix(index, value);
}

int gmcal_multiplyMatrixByMatrix(symrec *params)
{
  symrec pars;
  int index;
  int index2;
  double value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  index2=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Multipliing matrix %d by %g times matrix %d\n", index, value, index2); 
  
  return gmcal_script_multiply_matrix_by_matrix(index, index2, value);
}

int gmcal_multiplyMatrixByNumber(symrec *params)
{
  symrec pars;
  int index;
  double value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Multipliing matrix %d by %g\n", index, value);
  return gmcal_script_multiply_matrix_by_number(index, value);
}

int gmcal_divideMatrixByMatrix(symrec *params)
{
  symrec pars;
  int index;
  int index2;
  double value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  index2=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Dividing matrix %d by %g times matrix %d\n", index, value, index2); 
  
  return gmcal_script_divide_matrix_by_matrix(index, index2, value);
}

int gmcal_divideMatrixByNumber(symrec *params)
{
  symrec pars;
  int index;
  double value;
  
  pars=*params;
  
  value=pars.value.d_var; pars=*(pars.next);
  index=pars.value.l_var; 
  
  printf("Dividing matrix %d by %g\n", index, value);
  return gmcal_script_divide_matrix_by_number(index, value);
}

int gmcal_rowPolynom(symrec *params)
{
  symrec pars;
  int index;
  int row;
  double a0, a1, a2, a3, a4, a5;
  
  pars=*params;
  
  a5=pars.value.d_var; pars=*(pars.next);
  a4=pars.value.d_var; pars=*(pars.next);
  a3=pars.value.d_var; pars=*(pars.next);
  a2=pars.value.d_var; pars=*(pars.next);
  a1=pars.value.d_var; pars=*(pars.next);
  a0=pars.value.d_var; pars=*(pars.next);
  row=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Calculating X-Col %d of Matrix %d, a0=%g, a1=%g, a2=%g, a3=%g, a4=%g, a5=%g\n\n", row, index, a0, a1, a2, a3, a4, a5); 
  
  return gmcal_script_row_polynom(index, row, a0, a1, a2, a3, a4, a5);
}

int gmcal_colPolynom(symrec *params)
{
  symrec pars;
  int index;
  int col;
  double a0, a1, a2, a3, a4, a5;
  
  pars=*params;
  
  a5=pars.value.d_var; pars=*(pars.next);
  a4=pars.value.d_var; pars=*(pars.next);
  a3=pars.value.d_var; pars=*(pars.next);
  a2=pars.value.d_var; pars=*(pars.next);
  a1=pars.value.d_var; pars=*(pars.next);
  a0=pars.value.d_var; pars=*(pars.next);
  col=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Calculating Y-column %d of Matrix %d, a0=%g, a1=%g, a2=%g, a3=%g, a4=%g, a5=%g\n\n", col, index, a0, a1, a2, a3, a4, a5); 
  
  return gmcal_script_col_polynom(index, col, a0, a1, a2, a3, a4, a5);
}

int gmcal_flipMatrixRows(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Flipping rows of matrix %d\n", index); 
  
  return gmcal_script_flip_matrix_rows(index);
}

int gmcal_flipMatrixCols(symrec *params)
{
  symrec pars;
  
  int index;
  
  pars=*params;
  
  index=pars.value.l_var;
  
  printf("Flipping cols of matrix %d\n", index); 
  
  return gmcal_script_flip_matrix_cols(index);
}

int gmcal_createResizedMatrix(symrec *params)
{
  symrec pars;
  int index;
  int newX;
  int newY;
  
  pars=*params;
  
  newY=pars.value.l_var; pars=*(pars.next);
  newX=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Creating resized matrix with %d cols and %d rows from matrix %d\n", newX, newY, index); 
  
  return gmcal_script_create_resized_matrix(index, newX, newY);
}

int gmcal_createMatrixFromRow(symrec *params)
{
  symrec pars;
  int index;
  int row;
  int count;
  
  pars=*params;
  
  count=pars.value.l_var; pars=*(pars.next);
  row=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Creating matrix with %d rows from row %d of matrix %d\n", count, row, index); 
  
  return gmcal_script_create_matrix_from_row(index, row, count);
}

int gmcal_setDispersionXfromRow(symrec *params)
{
  symrec pars;
  int index;
  int row;
  int target;
  
  pars=*params;
  
  row=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var; pars=*(pars.next);
  target=pars.value.l_var;
  
  printf("Setting X-dispersion of matrix %d rows from row %d of matrix %d\n", target, row, index); 
  
  return gmcal_script_set_dispersion_x_from_row(target, index, row);
}

int gmcal_createPlanckFromX(symrec *params)
{
  symrec pars;
  double temp;
  int index;
  
  pars=*params;
  
  temp=pars.value.d_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Calculating Planck curve from X dispersion of matrix %d and temperature %g\n", index, temp); 
  
  return gmcal_script_create_planck_from_x(index, temp);
}

int gmcal_createSplineFromXAndRow(symrec *params)
{
  symrec pars;
  int row;
  int steps;
  double minX;
  double maxX;
  int index;
  
  pars=*params;
  
  steps=pars.value.l_var; pars=*(pars.next);
  maxX=pars.value.d_var; pars=*(pars.next);
  minX=pars.value.d_var; pars=*(pars.next);
  row=pars.value.l_var; pars=*(pars.next);
  index=pars.value.l_var;
  
  printf("Calculating spline curve from X dispersion and row %d of matrix %d (%g to %g in %d steps\n", row ,index, minX, maxX, steps); 
  
  return gmcal_script_create_spline_from_x_and_row(index, row, minX, maxX, steps);
}

