#include <gfit_engine_profile.h>

gint gfit_assign	(gdouble *target, gint num, gdouble **value);
gint gfit_add		(gdouble *target, gint num, gdouble **value);
gint gfit_sub		(gdouble *target, gint num, gdouble **value);
gint gfit_mul		(gdouble *target, gint num, gdouble **value);
gint gfit_div		(gdouble *target, gint num, gdouble **value);
gint gfit_sin		(gdouble *target, gint num, gdouble **value);
gint gfit_cos		(gdouble *target, gint num, gdouble **value);
gint gfit_tan		(gdouble *target, gint num, gdouble **value);
gint gfit_cot		(gdouble *target, gint num, gdouble **value);
gint gfit_polynom	(gdouble *target, gint num, gdouble **value);
gint gfit_exp		(gdouble *target, gint num, gdouble **value);


#ifdef __GFIT_FIT_C__

typedef struct {
  int (*fnct)(double *target, int num, double **value);
  int min;
  int max;
  char *name;
  char *desc;
} GFitEngineFunction;

GFitEngineFunction
gfit_fit_engine_functions[]={
  {gfit_assign,		2,	-1,	"assign",	"Result=Assign(Variable)"},
  {gfit_add,		2,	-1,	"add",		"Result=Add(Summand1, Summand2[, ...])"},
  {gfit_sub,		2,	-1,	"sub",		"Result=Sub(Minuend, Subtrahend1[, ...])"},
  {gfit_mul,		2,	-1,	"mul",		"Result=Mul(Factor1, Factor2[, ...])"},
  {gfit_div,		2,	-1,	"div",		"Result=Div(Dividend, Divisor1[, ...])"},
  {gfit_sin,		4,	4,	"sin", 		"Result=Sin(X, Amplitude, Wavelength, Phase)"},
  {gfit_cos,		4,	4,	"cos", 		"Result=Cos(X, Amplitude, Wavelength, Phase)"},
  {gfit_tan,		4,	4,	"tan", 		"Result=Tan(X, Amplitude, Wavelength, Phase)"},
  {gfit_cot,		4,	4,	"cot", 		"Result=Cot(X, Amplitude, Wavelength, Phase)"},
  {gfit_polynom,	3,	-1,	"polynom", 	"Result=Cot(X, X0, A0[, A1[, A2...]])"},
  {gfit_gauss,		4,	4,	"gauss", 	"Result=Gauss(X, X0, Y0, FWHM)"},
  {gfit_lorentz,	4,	4,	"lorentz", 	"Result=Lorentz(X, X0, Y0, FWHM)"},
  {gfit_voigt,		5,	5,	"voigt", 	"Result=Voigt(X, X0, Y0, FWHMGauss, FWHMLorentz)"},
  {gfit_exp,		3,	3,	"exp", 		"Result=Exp(X, Amplitude, Tau)"},
};

gint
gfit_fit_engine_functions_num=sizeof(gfit_fit_engine_functions)/sizeof(gfit_fit_engine_functions[0]);

#endif  /* __GFIT_FIT_C__ */

