#include <stdio.h>
#include <gfit.h>
#include <gfit_menus.h>
#include <gfit_show.h>
#include <gtk/gtkdatabox.h>

static guint gfit_counter=0;

static GtkWidget*	gfit_window_new(gchar *title, guint type, gfit_data *gfit);
static void 		gfit_window_destroy_cb(GtkWidget *widget, gpointer callback_data);


/*--------------------------------------------------------------
 *
 *               EXTERNAL FUNCTIONS
 *
 *--------------------------------------------------------------*/


void
gfit_new()
{
  GtkWidget *menubar;
  gfit_data *gfit=(gfit_data *) g_malloc0(sizeof(gfit_data));

  gfit_counter++;

  gfit->window=gfit_window_new ("gfit", GTK_WINDOW_TOPLEVEL, gfit);

  gfit->vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER (gfit->window), gfit->vbox);

  gtk_widget_realize(gfit->window);

  menubar=gfit_menu_bar_create("<Main>", gfit);
  gtk_box_pack_start(GTK_BOX (gfit->vbox), menubar, FALSE, TRUE, 0);
  gfit->box=gfit_show_create(gfit->vbox);


  gtk_widget_show_all (gfit->window);

  gfit->path="Enter file name";
  gfit->info=NULL;
  gfit->par_table=NULL;
  gfit->open_type=-1;
  gfit->save_type=-1;
  gfit->fit_flag=0;

  return;
}

void
gfit_close(gfit_data *gfit)
{
  if (gfit) {
    if (gfit->dialog) {
      printf("Aaaaaarg\n");
      gtk_widget_destroy(gfit->dialog);
    }
    if (gfit->window) {
      printf("Closing Window\n");
      gtk_widget_destroy(gfit->window);
    }
  }
  /* Data must be destroyed, too */
}

void
gfit_exit()
{
  gtk_exit(1);

  /* Data must be destroyed, too */
}

void gfit_warning(gchar *text)
{
  printf("%s\n", text);
}

/*--------------------------------------------------------------
 *
 *               INTERNAL FUNCTIONS
 *
 *--------------------------------------------------------------*/

static GtkWidget*
gfit_window_new(gchar *title, guint type, gfit_data *gfit)
{
  GtkWidget *window;

  window=gtk_window_new(type);
  gtk_window_set_title(GTK_WINDOW(window), title);
  gtk_container_border_width (GTK_CONTAINER (window), 0);
  if (type==GTK_WINDOW_TOPLEVEL) {
    gtk_signal_connect(GTK_OBJECT(window), "destroy",
			GTK_SIGNAL_FUNC(gfit_window_destroy_cb),
			gfit);
  } else {
    gtk_signal_connect(GTK_OBJECT(window), "destroy",
    			GTK_SIGNAL_FUNC(gtk_widget_destroyed),
    			&window);
  }
  return window;
}

static void
gfit_window_destroy_cb(GtkWidget *widget, gpointer callback_data)
{
  gfit_counter--;

  printf("window_destroy\n");

  if (!gfit_counter) {
    gtk_exit(1);
  }
}

